function Rec = ReconstructData(W, H, D, comp)

% Reconstructs the data from components estimated in the SISC model
%
% Usage 
%   Rec = ReconstructData(W, H, D, comp)
%
% Input:
%   W,H,D same as in SISC.m
%   comp    vector indicating components to reconstruct
%
% Output:
%   Rec     Reconstructed array

Rec = zeros(size(H,3)+size(W,1)-1,size(H,2)+size(W,3)-1,size(D,1));
RecWH=zeros([size(Rec,1),size(Rec,2),length(comp)]);
for t=1:length(comp)
    RecWH(:,:,t) = conv2(squeeze(W(:,comp(t),:)),squeeze(H(comp(t),:,:))');         
end
Dt(1,:,:)=D(:,comp);
for k=1:size(D,1)   
    T=sum(repmat(Dt(1,k,:),[size(RecWH,1),size(RecWH,2),1]).*RecWH,3);
    Rec(:,:,k) = T;
end

